## org.jgroups.protocols
Class BARRIER

    java.lang.Object
      org.jgroups.stack.Protocol
          org.jgroups.protocols.BARRIER

    public class BARRIER

extends Protocol

All messages up the stack have to go through a barrier (read lock, RL). By default, the barrier is open. When a CLOSE_BARRIER event is received, we close the barrier by acquiring a write lock (WL). This succeeds when all previous messages have completed (by releasing their RLs). Thus, when we have acquired the WL, we know that there are no pending messages processed.
When an OPEN_BARRIER event is received, we simply open the barrier again and let all messages pass in the up direction. This is done by releasing the WL.

Author:
  Bela Ban

Field Summary

Fields inherited from class org.jgroups.stack.Protocol
`down_prot, ergonomics, id, log, name, stack, stats, up_prot`

Constructor Summary
`BARRIER()`

Method Summary
`void` `destroy()` This method is called on a `Channel.close()`.
`java.lang.Object` `down(Event evt)` An event is to be sent down the stack.
`int` `getInFlightThreadsCount()`
`int` `getNumberOfInFlightThreads()`
`void` `init()` Called after instance has been created (null constructor) and before protocol is started.
`boolean` `isClosed()`
`boolean` `isOpenerScheduled()`
`void` `stop()` This method is called on a `Channel.disconnect()`.
`java.lang.Object` `up(Event evt)` An event was received from the layer below.

Methods inherited from class org.jgroups.stack.Protocol

`downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, isErgonomics, printStats, providedDownServices, providedUpServices, requiredDownServices, requiredUpServices, resetStats, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, start, statsEnabled, upThreadEnabled`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BARRIER

    public BARRIER()

Method Detail

### isClosed

    public boolean isClosed()

### getNumberOfInFlightThreads

    public int getNumberOfInFlightThreads()

### getInFlightThreadsCount

    public int getInFlightThreadsCount()

### isOpenerScheduled

    public boolean isOpenerScheduled()

### init

    public void init()
              throws java.lang.Exception

  Description copied from class: `Protocol`
  Called after instance has been created (null constructor) and before protocol is started. Properties are already set. Other protocols are not yet connected and events cannot yet be sent.

  Overrides:
    `init` in class `Protocol`
  Throws:
    `java.lang.Exception` - Thrown if protocol cannot be initialized successfully. This will cause the ProtocolStack to fail, so the channel constructor will throw an exception

### stop

    public void stop()

  Description copied from class: `Protocol`
  This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed

  Overrides:
    `stop` in class `Protocol`

### destroy

    public void destroy()

  Description copied from class: `Protocol`
  This method is called on a `Channel.close()`. Does some cleanup; after the call the VM will terminate

  Overrides:
    `destroy` in class `Protocol`

### down

    public java.lang.Object down(Event evt)

  Description copied from class: `Protocol`
  An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.

  Overrides:
    `down` in class `Protocol`

### up

    public java.lang.Object up(Event evt)

  Description copied from class: `Protocol`
  An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.

  Overrides:
    `up` in class `Protocol`

Copyright © 1998-2009 Bela Ban / Red Hat. All Rights Reserved.